live-build/helpers/lh_binary_usb-hdd

216 lines
4.4 KiB
Plaintext
Raw Normal View History

2007-09-23 08:04:46 +00:00
#!/bin/sh
2007-09-23 08:05:11 +00:00
# lh_binary_usb-hdd(1) - build binary usb-hdd image
2008-03-06 14:43:00 -01:00
# Copyright (C) 2006-2008 Daniel Baumann <daniel@debian.org>
2007-09-23 08:04:48 +00:00
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.
2007-09-23 08:04:46 +00:00
set -e
2007-09-23 08:05:11 +00:00
# Including common functions
LH_BASE="${LH_BASE:-/usr/share/live-helper}"
for FUNCTION in "${LH_BASE}"/functions/*.sh
2007-09-23 08:04:46 +00:00
do
2007-09-23 08:05:11 +00:00
. "${FUNCTION}"
2007-09-23 08:04:46 +00:00
done
2007-09-23 08:05:11 +00:00
# Setting static variables
2007-09-23 08:04:48 +00:00
DESCRIPTION="build binary image"
HELP=""
USAGE="${PROGRAM} [--force]"
Arguments "${@}"
2007-09-23 08:04:46 +00:00
# Reading configuration files
2008-04-07 10:10:21 +00:00
Read_conffile config/all config/common config/bootstrap config/chroot config/binary config/source
2007-09-23 08:04:46 +00:00
Set_defaults
2007-09-23 08:05:17 +00:00
if ! echo "${LH_BINARY_IMAGES}" | grep -qs usb-hdd
2007-09-23 08:05:11 +00:00
then
exit 0
fi
Echo_message "Begin building binary usb-hdd image..."
# Requiring stage file
Require_stagefile .stage/bootstrap
Require_stagefile .stage/chroot_proc
# Checking stage file
Check_stagefile .stage/binary_usb-hdd
# Checking lock file
Check_lockfile .lock
# Creating lock file
Create_lockfile .lock
# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
2007-09-23 08:05:16 +00:00
Check_package chroot/usr/share/doc/mtools mtools
2007-09-23 08:05:11 +00:00
Check_package chroot/sbin/parted parted
2007-09-23 08:05:17 +00:00
case "${LH_BOOTLOADER}" in
2007-09-23 08:05:11 +00:00
grub)
Check_package chroot/usr/sbin/grub grub
;;
syslinux)
Check_package chroot/usr/bin/syslinux syslinux
;;
esac
2007-09-23 08:05:15 +00:00
# Restoring cache
Restore_cache cache/packages_binary
2007-09-23 08:05:11 +00:00
# Installing depends
Install_package
# Remove old binary
if [ -f binary.img ]
then
rm -f binary.img
fi
# Everything which comes here needs to be cleaned up,
DU_DIM="$(du -ms binary | cut -f1)"
REAL_DIM="$(expr ${DU_DIM} + ${DU_DIM} / 50 + 1)" # Just 2% more to be sure, need something more sophistcated here...
dd if=/dev/zero of=chroot/binary.img bs=1024k count=0 seek=${REAL_DIM}
FREELO="$(${LH_LOSETUP} -f)"
2007-09-23 08:05:11 +00:00
if [ ! -b chroot/${FREELO} ]
then
MAKEDEV="true"
mv chroot/dev chroot/dev.tmp
find /dev | cpio -dmpu chroot
fi
echo "!!! The following error/warning messages can be ignored !!!"
Losetup $FREELO chroot/binary.img 0
2007-09-23 08:05:11 +00:00
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
2007-09-23 08:05:16 +00:00
enabled)
Chroot "parted -s ${FREELO} mklabel msdos" || true
2007-11-18 09:33:46 -01:00
Chroot "parted -s ${FREELO} mkpart primary ${LH_BINARY_FILESYSTEM} 0.0 100%" || true
2007-09-23 08:05:16 +00:00
Chroot "parted -s ${FREELO} set 1 boot on" || true
Chroot "parted -s ${FREELO} set 1 lba off" || true
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:16 +00:00
then
cat chroot/usr/lib/syslinux/mbr.bin > ${FREELO}
fi
;;
disabled)
parted -s ${FREELO} mklabel msdos || true
2007-11-18 09:33:46 -01:00
parted -s ${FREELO} mkpart primary ${LH_BINARY_FILESYSTEM} 0.0 100% || true
2007-09-23 08:05:16 +00:00
parted -s ${FREELO} set 1 boot on || true
parted -s ${FREELO} set 1 lba off || true
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:16 +00:00
then
cat /usr/lib/syslinux/mbr.bin > ${FREELO}
fi
;;
esac
2007-09-23 08:05:11 +00:00
${LH_LOSETUP} -d ${FREELO}
FREELO="$(${LH_LOSETUP} -f)"
Losetup $FREELO chroot/binary.img 1
2007-09-23 08:05:16 +00:00
case "${LH_BINARY_FILESYSTEM}" in
fat16)
MKFS_OPTIONS="-F 16"
;;
fat32)
MKFS_OPTIONS="-F 32"
;;
esac
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
2007-09-23 08:05:16 +00:00
enabled)
Chroot "mkfs.vfat ${MKFS_OPTIONS} -n DEBIAN_LIVE ${FREELO}"
2007-09-23 08:05:16 +00:00
;;
disabled)
mkfs.vfat ${MKFS_OPTIONS} -n DEBIAN_LIVE ${FREELO}
2007-09-23 08:05:16 +00:00
;;
esac
2007-09-23 08:05:12 +00:00
mkdir -p chroot/binary.tmp
${LH_ROOT_COMMAND} mount ${FREELO} chroot/binary.tmp
2007-09-23 08:05:13 +00:00
cp -rL binary/* chroot/binary.tmp
2007-09-23 08:05:12 +00:00
FIXME()
{
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "grub" ]
2007-09-23 08:05:12 +00:00
then
cat > chroot/grub.sh << EOF
cd binary.tmp
grub --batch << EOM
find /live/vmlinuz
EOM
EOF
rootpartition="$(Chroot 'sh grub.sh' 2>/dev/null | grep -A 1 'find /live/vmlinuz' | grep -v 'find /live/vmlinuz')"
usbdev="$(echo $rootpartition | sed -e 's|,[[:digit:]]||')"
2007-09-23 08:05:12 +00:00
echo "Root partition is $rootpartition, device is: $usbdev"
echo "WAITING..." && read WAIT
2007-09-23 08:05:12 +00:00
#cat > chroot/grub.sh << EOF
#grub --batch << EOM
#root $rootpartition
#setup $usbdev
#EOM
#EOF
#Chroot "sh grub.sh"
rm -f chroot/grub.sh
fi
}
${LH_ROOT_COMMAND} umount chroot/binary.tmp
rmdir chroot/binary.tmp
2007-09-23 08:05:11 +00:00
2007-09-23 08:05:17 +00:00
if [ "${LH_BOOTLOADER}" = "syslinux" ]
2007-09-23 08:05:11 +00:00
then
2007-09-23 08:05:17 +00:00
case "${LH_CHROOT_BUILD}" in
2007-09-23 08:05:16 +00:00
enabled)
Chroot "syslinux ${FREELO}"
;;
disabled)
syslinux ${FREELO}
;;
esac
2007-09-23 08:05:11 +00:00
fi
${LH_LOSETUP} -d ${FREELO}
echo "!!! The above error/warning messages can be ignored !!!"
if [ -n "${MAKEDEV}" ]
then
2007-09-23 08:05:13 +00:00
rm -rf chroot/dev
2007-09-23 08:05:11 +00:00
mv chroot/dev.tmp chroot/dev
fi
2007-09-23 08:05:12 +00:00
mv chroot/binary.img ./
2007-09-23 08:05:15 +00:00
# Saving cache
Save_cache cache/packages_binary
2007-09-23 08:05:11 +00:00
# Removing depends
Remove_package
# Creating stage file
Create_stagefile .stage/binary_usb-hdd